/**
 * \file    Mimic_Boolean.hpp
 * \author  Silvan Murer
 * \date    02 August 2022
 *
 * \brief   Boolean class of genSDK GF implementation, based on Mimic_Node
 */

#ifndef INC_FEATURES_MIMIC_BOOLEAN
#define INC_FEATURES_MIMIC_BOOLEAN

#include "features/Mimic_Node.hpp"

#include <memory>
#include <string>

namespace mimic {

class Mimic_Boolean : public Mimic_Node
{
private:

public:
	Mimic_Boolean();
	Mimic_Boolean(GenApi_3_4::INode* node);
	virtual ~Mimic_Boolean();

	virtual std::variant<int64_t, double, bool, std::string> getVariant(std::string name);
	virtual void setVariant(std::string name, std::variant<int64_t, double, bool, std::string> value);

	bool getValue();
	void setValue(bool value);
};

} /* namespace mimic */

#endif
